package ch.zhaw.projekt2.turnierverwaltung;

import javafx.scene.layout.Pane;

public abstract class FXController {
    Tournament tournament;
    TournamentDecorator tournamentDecorator;
    Factory factory;
    FileIO fileIO;
    Pane pane;

    public void setup(Tournament tournament, FileIO fileIO, Factory factory, Pane pane){
        setTournament(tournament);
        this.fileIO = fileIO;
        this.factory = factory;
        this.pane = pane;
        tournamentDecorator = new TournamentDecorator(fileIO, tournament);
        tournamentDecorator.addListener(new IsObserver() {
            @Override
            public void update() {
                loadContent();
            }
        });
    }

    public abstract void loadContent();

    public void setTournament(Tournament tournament) {
        this.tournament = tournament;
        tournamentDecorator.setTournament(tournament);
    }

    protected TournamentDecorator getTournamentDecorator() {
        return tournamentDecorator;
    }

    protected FileIO getFileIO() {
        return fileIO;
    }

    protected Factory getFactory() {
        return factory;
    }

    protected Pane getPane() {
        return pane;
    }
}
